Bug 530688 - (ghc-language-c) Review Request: ghc-language-c - Haskell language-c library
Review Request: ghc-language-c - Haskell language-c library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jens Petersen
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: 736801
  Show dependency treegraph
 
Reported: 2009-10-24 02:58 EDT by Michel Alexandre Salim
Modified: 2011-10-15 20:55 EDT (History)
5 users (show)

See Also:
Fixed In Version: ghc-language-c-0.4.2-3.fc16
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-10-13 19:53:32 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
petersen: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Michel Alexandre Salim 2009-10-24 02:58:47 EDT
Spec URL: http://salimma.fedorapeople.org/specs/funpl/ghc-language-c.spec
SRPM URL: http://salimma.fedorapeople.org/specs/funpl/ghc-language-c-0.3.1.1-1.fc12.src.rpm
Description:
Language C is a haskell library for the analysis and generation of C
code.  It features a complete, well tested parser and pretty printer
for all of C99 and a large set of GNU extensions.
Comment 1 Jens Petersen 2009-10-29 04:41:58 EDT
Looks fine to me.
Comment 2 Bryan O'Sullivan 2009-11-13 00:28:45 EST
MUST: rpmlint must be run on every package.

$ rpmlint ghc-language-c-devel-0.3.1.1-1.fc11.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
$ rpmlint ghc-language-c-doc-0.3.1.1-1.fc11.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
$ rpmlint ghc-language-c-prof-0.3.1.1-1.fc11.x86_64.rpm
ghc-language-c-prof.x86_64: E: devel-dependency ghc-language-c-devel
ghc-language-c-prof.x86_64: W: no-documentation
ghc-language-c-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.10.3/language-c-0.3.1.1/libHSlanguage-c-0.3.1.1_p.a
1 packages and 0 specfiles checked; 1 errors, 2 warnings.

OK. All expected.

MUST: The package must be named according to the Package Naming Guidelines.

OK.

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.

OK.

MUST: The package must meet the Packaging Guidelines.

OK.

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.

OK.

MUST: The License field in the package spec file must match the actual license.

OK.

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

OK.

MUST: The spec file must be written in American English.

OK.

MUST: The spec file for the package MUST be legible.

OK.

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

OK.

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.

OK.

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.

OK.

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional.

OK.

MUST: The spec file MUST handle locales properly.

NA.

MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.

NA.

MUST: Packages must NOT bundle copies of system libraries.

NA.

MUST: If the package is designed to be relocatable,...

NA.

MUST: A package must own all directories that it creates.

OK.

MUST: A Fedora package must not list a file more than once in the spec file's %files listings.

OK.

MUST: Permissions on files must be set properly.

OK.

MUST: Each package must have a %clean section

OK.

MUST: Each package must consistently use macros.

OK.

MUST: The package must contain code, or permissable content.

OK.

MUST: Large documentation files must go in a -doc subpackage.

OK.

MUST: If a package includes something as %doc, it must not affect the runtime of the application.

OK.

MUST: Header files must be in a -devel package.

NA.

MUST: Static libraries must be in a -static package.

NA.

MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).

NA.

MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1)

NA.

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}

OK.

MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.

OK.

MUST: Packages containing GUI applications must 

NA.

MUST: Packages must not own files or directories already owned by other packages.

OK.

MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).

OK.

MUST: All filenames in rpm packages must be valid UTF-8. [27]

OK.

This package is APPROVED.
Comment 3 Jens Petersen 2009-11-23 19:59:02 EST
Michel will you do a CVS Request?
Comment 4 Jens Petersen 2009-12-21 05:02:26 EST
https://fedoraproject.org/wiki/CVS_admin_requests

ping?
Comment 5 Jens Petersen 2010-01-11 04:15:45 EST
reping
Comment 6 Jens Petersen 2010-01-27 19:42:11 EST
Michel?
Comment 7 Jens Petersen 2010-02-14 21:04:24 EST
Pinging again.

This package was approved in November and still no cvs request or build.
Comment 8 Jens Petersen 2010-04-08 08:17:09 EDT
Ping again!?
Comment 9 Jens Petersen 2010-04-08 08:18:46 EDT
If Michel doesn't want/need this package any more perhaps we should just close it for now?

Or does someone else wish to take it over?
Comment 10 Jens Petersen 2010-06-03 00:14:42 EDT
Closing this deferred since noone seems interested.

Sorry, Bryan, about the wasted effort...

If someone wants to pick it up again please reopen.
Comment 11 Michel Alexandre Salim 2011-09-08 12:09:35 EDT
Somehow this slipped out of my radar, sorry. I'm assuming there needs to be a re-review, with a cabal2spec-generated template?
Comment 12 Michel Alexandre Salim 2011-09-08 12:56:29 EDT
Spec URL: http://salimma.fedorapeople.org/specs/funpl/ghc-language-c.spec
SRPM URL: 
http://salimma.fedorapeople.org/specs/funpl/ghc-language-c-0.4.2.fc15.src.rpm

(rebased using cabal2spec-0.24 from Fedora 16)

Koji build for Fedora 15:
http://koji.fedoraproject.org/koji/taskinfo?taskID=3335866
Comment 13 Jens Petersen 2011-09-08 23:22:09 EDT
Ok, taking over this restarted review at Michel's request after checking with Bryan.
Comment 14 Michel Alexandre Salim 2011-09-09 13:00:12 EDT
updated srpm:
http://salimma.fedorapeople.org/specs/funpl/ghc-language-c-0.4.2.fc15.src.rpm

the manually-added BuildRequires are also needed at runtime, otherwise the Language.C* modules cannot be imported. Tested with the linked pure-gen review request
Comment 15 Jens Petersen 2011-09-13 21:46:14 EDT
(In reply to comment #14)
> http://salimma.fedorapeople.org/specs/funpl/ghc-language-c-0.4.2.fc15.src.rpm

I guess you mean:
 http://salimma.fedorapeople.org/specs/funpl/ghc-language-c-0.4.2-2.fc15.src.rpm
:)

> the manually-added BuildRequires are also needed at runtime, otherwise the
> Language.C* modules cannot be imported. Tested with the linked pure-gen review
> request

I think this is a bug in current f15 and f14 ghc-rpm-macros as I just discovered this week, when using cabal2spec-0.24.

I have backported a fix from F16 so that ghc-dep.sh gets activated also for
the newer templates in cabal2spec-0.24:

https://admin.fedoraproject.org/updates/ghc-rpm-macros-0.13.10-1.fc15
https://admin.fedoraproject.org/updates/ghc-rpm-macros-0.13.10-1.fc14

and those builds are in Koji override until the end of next week
to avoid this issue.  Perhaps you could test that it solves your problem?
Comment 16 Jens Petersen 2011-09-13 21:56:03 EDT
Apart from the last change the package looks fine to me and rpmlint is clean.
Comment 17 Michel Alexandre Salim 2011-09-26 11:38:44 EDT
Didn't manage to catch it in Koji, sorry. It worked fine on a local build -- rpm -qp --requires on the built package now show the correct dependencies, so I've updated the package:

http://salimma.fedorapeople.org/specs/funpl/ghc-language-c-0.4.2-3.fc15.src.rpm

and voted up the update on Bodhi
Comment 19 Jens Petersen 2011-09-28 03:24:55 EDT
Here is the review:

 +:ok, NA: not applicable

MUST Items:
[+] MUST: rpmlint output

rpmlint clean

[+] MUST: Package Naming Guidelines
[+] MUST: spec file name must match base package %{name}
[+] MUST: Packaging Guidelines.
[+] MUST: Licensing Guidelines
[+] MUST: License field in the package spec file must match actual license.
[+] MUST: include license files in %doc if available in source
[+] MUST: The spec file must be written in American English and be legible.
[+] MUST: source md5sum matches upstream release

7b0ba1e90b53f7ea9883f9a6cf07d3d4  language-c-0.4.2.tar.gz

[+] MUST: must successfully compile and build into binary rpms on one main arch
[+] MUST: if necessary use ExcludeArch for other archs
[+] MUST: All build dependencies must be listed in BuildRequires
[NA] MUST: use %find_lang macro for .po translations
[NA] MUST: packages which store shared library files in the dynamic linker's default paths, must call ldconfig in %post and %postun.
[NA] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review
[+] MUST: A package must own all directories that it creates.
[+] MUST: A package must not contain any duplicate files in the %files listing.
[+] MUST: Permissions on files must be set properly.
[+] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines.
[+] MUST: The package must contain code, or permissable content.
[NA] MUST: Large documentation files should go in a doc subpackage.
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[+] MUST: Header files must be in a -devel package.
[NA] MUST: Static libraries must be in a -static package.
[NA] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in
a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency
[+] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[NA] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD Items:
[+] SHOULD: If scriptlets are used, those scriptlets must be sane.

Package is APPROVED.
Comment 20 Michel Alexandre Salim 2011-10-04 05:35:17 EDT
New Package SCM Request
=======================
Package Name: ghc-language-c
Short Description: Haskell library for C code analysis and generation
Owners: salimma
Branches: f15 f16
InitialCC: haskell-sig
Comment 21 Jon Ciesla 2011-10-04 08:17:43 EDT
Git done (by process-git-requests).
Comment 22 Fedora Update System 2011-10-04 12:16:52 EDT
ghc-language-c-0.4.2-3.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/ghc-language-c-0.4.2-3.fc15
Comment 23 Fedora Update System 2011-10-04 12:17:03 EDT
ghc-language-c-0.4.2-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/ghc-language-c-0.4.2-3.fc16
Comment 24 Fedora Update System 2011-10-04 16:47:01 EDT
ghc-language-c-0.4.2-3.fc16 has been pushed to the Fedora 16 testing repository.
Comment 25 Fedora Update System 2011-10-13 19:53:32 EDT
ghc-language-c-0.4.2-3.fc15 has been pushed to the Fedora 15 stable repository.
Comment 26 Fedora Update System 2011-10-15 20:55:38 EDT
ghc-language-c-0.4.2-3.fc16 has been pushed to the Fedora 16 stable repository.

Note You need to log in before you can comment on or make changes to this bug.